# -*- coding: utf-8 -*-
import re, json, time
import hashlib
try:
	from urllib2 import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import quote
except ImportError:
	from urllib.parse import quote

def httpget(url):
	try:
		file = urlopen(url, timeout = 3)
		content = file.read()
		file.close()
		content = content.decode('utf-8')
		return content
	except:
		print(url)
		print('captured')
		return False

def get(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'iqiyi 201'}
	sourceid = re.search('sourceId:\s*(\d+)', content)
	if sourceid == None:
		sourceid = re.search('data-player-albumid="(\d*)"', content)
		if sourceid == None:
			return {'success': False, 'code':'iqiyi 202'}
	sourceid = sourceid.group(1)
	cid = re.search('cid:\s*(\d+)', content)
	if cid == None:
		cid = '6'
	else:
		cid = cid.group(1)
	url = 'http://cache.video.qiyi.com/jp/sdvlst/' + cid + '/' + sourceid + '/'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'iqiyi 203'}
	content = re.search('var tvInfoJs=(.*)', content)
	if content == None:
		return {'success': False, 'code':'iqiyi 204'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'iqiyi 205'}
	result = {'success': True, 'item': []}
	for tv in data['data']:
		result['item'].append({'title':tv['tvYear'] + tv['tvSbtitle'], 'url':tv['vUrl']})
	return result

def play(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'iqiyi 301'}
	tvid = re.search('tvid="(.*?)"', content)
	if tvid == None:
		return {'success': False, 'code':'iqiyi 302'}
	tvid = tvid.group(1)
	videoid = re.search('videoid="(.*?)"', content)
	if videoid == None:
		return {'success': False, 'code':'iqiyi 303'}
	videoid = videoid.group(1)
	t = str(int(time.time() * 1000))
	src = '76f90cbd92f94a2e925d83e8ccd22cb7'
	key = 'd5fb4bd9d50c4be6948c97edd7254b0e'
	sc = hashlib.new('md5', (t + key + videoid).encode('utf-8')).hexdigest()
	url = 'http://cache.m.iqiyi.com/tmts/' + tvid + '/' + videoid + '/?t=' + t + '&sc=' + sc + '&src=' + src
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'iqiyi 304'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'iqiyi 305'}
	result = {'success': True, 'title': '', 'url': {}}
	for stream in data['data']['vidl']:
		result['url'][str(stream['vd'])] = stream['m3u']
	return result
